/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: DBPartParameters.java,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:23:21 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
package com.sun.xmlsearch.db;

import java.util.Hashtable;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import com.sun.xmlsearch.util.LineInput;

public class DBPartParameters {
  protected Schema _schema;
  private String _partName;
  private Hashtable _parameters;

  protected DBPartParameters() {}

  public DBPartParameters(Schema schema, String partName) {
    _schema = schema;
    _partName = partName;
    _parameters = schema.parameters(partName);
  }
  
  protected boolean parametersKnown() {
    return _parameters != null;
  }
  
  protected void updateSchema(String parameters) {
    _schema.update(_partName, parameters);
  }
  
  public int integerParameter(String name) {
    return Integer.parseInt(((String)_parameters.get(name)));
  }

  public File getFile() throws IOException {
    return _schema.indexFile(_partName);
  }
  
  public LineInput getSchemaLineInput() throws IOException {
    return _schema.getSchemaLineInput();
  }
  
  public FileWriter makeSchemaWriter() throws IOException {
    return _schema.makeSchemaWriter();
  }
}
