/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: DocumentServlet.java,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:35:28 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
package com.sun.xmlsearch.servlet;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public final class DocumentServlet extends HttpServlet {
  private static final String common = "\" name=\"toc\"></frameset><frame src=\"/servlet/text";
  
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
      response.setContentType("text/html");
      PrintWriter out = response.getWriter();
      out.write("<html><head><title>Document</title></head>");
      out.write("<frameset cols=\"30%,70%\">");
      out.write("<frameset rows=\"15%,85%\"><frame src=\"/servlet/query2\">");
      out.write("<frame src=\"/servlet/toc");
      
      String hit = request.getParameter("hit");	// hit seq number
      if (hit != null) {
	SearchState state = SearchState.getSearchState(request);
	state.retrieveDocumentFragment(hit);
	out.write("?hit=");
	out.write(hit);
	out.write(common);
	out.write("?hit=");
	out.write(hit);
      }
      else {
	String doc = request.getParameter("doc");
	if (doc != null) {
	  SearchState state = SearchState.getSearchState(request);
	  state.retrieveDocument(doc);
	  out.write("?doc=");
	  out.write(doc);
	  out.write(common);
	  out.write("?doc=");
	  out.write(doc);
	}
	else
	  out.write(common);
      }
      out.write("\" name=\"text\"></frameset></html>");
      out.close();
  }
}
