/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: TextServlet.java,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:38:49 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
package com.sun.xmlsearch.servlet;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public final class TextServlet extends HttpServlet {
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
      SearchState state = SearchState.getSearchState(request);
      response.setContentType("text/html");
      String hit = request.getParameter("hit");
      if (hit != null) {
	OutputStream out = response.getOutputStream();
	state.retrieveHitArea(hit, out);
	out.close();
      }
      else {
	String fragment = request.getParameter("fragment");
	if (fragment != null) {
	  OutputStream out = response.getOutputStream();
	  state.retrieveDocumentFragment(fragment, out);
	  out.close();
	}
	else {
	  String doc = request.getParameter("doc");
	  if (doc != null) {
	    OutputStream out = response.getOutputStream();
	    // !!! bad function name in this case
	    state.retrieveHitArea(doc, out);
	    out.close();
	  }
	  else {
	    PrintWriter out = response.getWriter();
	    out.write("<html><head><title>Table of Contents</title></head>");
	    out.write("<body>document fragment...</body></html>");
	    out.close();
	  }
	}
      }
  }
}
