/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: TocTreePath.java,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:41:25 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
package com.sun.xmlsearch.tree;

import java.io.*;

public final class TocTreePath implements Externalizable {
  private TocTree _tree;
  private int[] _path;

  public TocTreePath() { /* for Externalizable */ }

  public TocTreePath(TocTree tree, int[] path) {
    _tree = tree;
    _path = path;
  }

  public TocTree.TocNode[] nodes() {
    return _tree.getNodes(_path);
  }

  public void readExternal(ObjectInput in)
    throws ClassNotFoundException, IOException {
      (_tree = new TocTree()).readExternal(in);
      _path = (int[]) in.readObject();
  }
  
  public void writeExternal(ObjectOutput out) throws IOException {
    _tree.writeExternal(out);
    out.writeObject(_path);
  }
}
