/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: WrappedSymbolProperties.hxx,v $
 *
 *  $Revision: 1.2.44.1 $
 *
 *  last change: $Author: obo $ $Date: 2007/08/17 09:20:58 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef CHART_WRAPPED_SYMBOL_PROPERTIES_HXX
#define CHART_WRAPPED_SYMBOL_PROPERTIES_HXX

#include "WrappedProperty.hxx"
#include "Chart2ModelContact.hxx"

#include <boost/shared_ptr.hpp>
#include <vector>

//.............................................................................
namespace chart
{
namespace wrapper
{

//-----------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------

class WrappedSymbolProperties
{
public:
    static void addProperties( ::std::vector< ::com::sun::star::beans::Property > & rOutProperties );
    static void addWrappedPropertiesForSeries( std::vector< WrappedProperty* >& rList
                    , ::boost::shared_ptr< Chart2ModelContact > spChart2ModelContact );
    static void addWrappedPropertiesForDiagram( std::vector< WrappedProperty* >& rList
                    , ::boost::shared_ptr< Chart2ModelContact > spChart2ModelContact );
};

} //namespace wrapper
} //namespace chart
//.............................................................................

// CHART_WRAPPED_SYMBOL_PROPERTIES_HXX
#endif
