/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: BKey.cxx,v $
 *
 *  $Revision: 1.12 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/17 02:07:40 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_connectivity.hxx"

#ifndef _CONNECTIVITY_ADABAS_KEY_HXX_
#include "adabas/BKey.hxx"
#endif
#ifndef _CONNECTIVITY_ADABAS_KEYCOLUMNS_HXX_
#include "adabas/BKeyColumns.hxx"
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XRESULTSET_HPP_
#include <com/sun/star/sdbc/XResultSet.hpp>
#endif
#ifndef _CONNECTIVITY_ADABAS_TABLE_HXX_
#include "adabas/BTable.hxx"
#endif
#ifndef _COMPHELPER_TYPES_HXX_
#include <comphelper/types.hxx>
#endif

using namespace connectivity::adabas;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
//	using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::lang;
// -------------------------------------------------------------------------
OAdabasKey::OAdabasKey(	OAdabasTable* _pTable) : sdbcx::OKey(sal_True),m_pTable(_pTable)
{
	construct();
}
// -------------------------------------------------------------------------
OAdabasKey::OAdabasKey(	OAdabasTable* _pTable,
			const ::rtl::OUString& _Name,
			const ::rtl::OUString& _ReferencedTable,
			sal_Int32		_Type,
			sal_Int32		_UpdateRule,
			sal_Int32		_DeleteRule
		  ) : sdbcx::OKey(_Name,
						  _ReferencedTable,
						  _Type,
						  _UpdateRule,
						  _DeleteRule,sal_True)
				,m_pTable(_pTable)
{
	construct();
}
// -------------------------------------------------------------------------
void OAdabasKey::refreshColumns()
{
	if(!m_pTable)
		return;

	TStringVector aVector;

	if(!isNew())
	{
		if(m_Name.getLength()) // foreign key
		{
			Reference< XResultSet > xResult = m_pTable->getMetaData()->getImportedKeys(Any(),
				m_pTable->getSchema(),m_pTable->getTableName());

			if(xResult.is())
			{
				Reference< XRow > xRow(xResult,UNO_QUERY);
				while(xResult->next())
				{
					if(m_Name == xRow->getString(12))
						aVector.push_back(xRow->getString(8));
				}
				::comphelper::disposeComponent(xResult);
			}
		}
		else
		{
			Reference< XResultSet > xResult = m_pTable->getMetaData()->getPrimaryKeys(Any(),
				m_pTable->getSchema(),m_pTable->getTableName());

			if(xResult.is())
			{
				Reference< XRow > xRow(xResult,UNO_QUERY);
				while(xResult->next())
					aVector.push_back(xRow->getString(4));
				::comphelper::disposeComponent(xResult);
			}
		}
	}

	if(m_pColumns)
		m_pColumns->reFill(aVector);
	else
		m_pColumns	= new OKeyColumns(this,m_aMutex,aVector);
}
// -----------------------------------------------------------------------------

