/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: struct.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2006/06/19 13:09:27 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include <precomp.h>
#include <udm/struct.hxx>


// NOT FULLY DEFINED SERVICES





namespace udm
{

Struct::~Struct()
{
}



void
Struct::do_BinWrite( csv::bostream & o_out ) const
{
    for ( member_id m = 0; m <= size(); ++m )
    {
     	Object obj = member(m);
        if (obj)
        {
            o_out.write(&m, sizeof(member_id));
            obj.bin_write(o_out);
        }
    }
}

#if 0
void
Struct::do_XmlWrite( csv::bostream & o_out ) const
{
    o_out.write("\n<struct>");
    for ( member_id m = 1; m <= max_member_id(); ++m )
    {
        xml_WriteMember(o_out, m);
    }
    o_out.write("</struct>\n");
}
#endif // 0

Data::accessor_type
Struct::inq_Type() const
{
 	return t_Struct;
}

Struct::description
Struct::inq_TypeDescription() const
{
    // KORR
 	return "S{}";
}

Struct &
Struct::access_Struct()
{
 	return *this;
}

#if 0
void
Struct::xml_WriteMember( csv::bostream &    o_out,
                         member_id          i_m ) const
{
    static StreamStr sNr(10);

    Object obj = member(i_m);
    if (obj)
    {
        o_out.write("\n<member nr=\"");
        sNr.seekp(0);
        sNr << i_m;
        o_out.write(sNr.c_str());
        o_out.write("\">");

        obj.xml_write(o_out);

        o_out.write("</member>\n");
    }
}
#endif // 0




//*********************       Struct_Null      *******************//

class Struct_Null : public Struct
{
  public:
    virtual             ~Struct_Null();

  private:
    // Interface Data
    virtual void        do_Dispose();
    virtual void        do_BinWrite(
                            csv::bostream &     o_out ) const;
    virtual description inq_TypeDescription() const;

    // Interface Struct
    virtual Object      inq_Member(
                            member_id           i_m ) const;
    virtual Object      inq_SearchByKey(
                            int                 i_nKey ) const;
    virtual member_id   size() const;
};


Struct_Null::~Struct_Null()
{
}

void                Struct_Null::do_Dispose() { }
void                Struct_Null::do_BinWrite( csv::bostream & ) const    {}
Data::description   Struct_Null::inq_TypeDescription() const { return "S{}"; }


Object
Struct_Null::inq_Member( member_id ) const
{
    return Object();
}

Object
Struct_Null::inq_SearchByKey( int ) const
{
    return Object();
}

member_id
Struct_Null::size() const
{
    return 0;
}


template <>
Struct &
get_null<Struct>( csv::Type2Type<Struct> )
{
    static Struct * pNull_ = new Struct_Null;
    return *pNull_;
}





}   // namespace udm



